// SimuRoute.cpp


#include "stdafx.h"
#include "SimuRoute.h"
#include "MainFrame.h"

#include "ChildFrame.h"
#include "Doc.h"
#include "GraphView.h"

#include "DlgProperties.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BEGIN_MESSAGE_MAP(CApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW,  CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()


CApp app;


// Constructor
CApp::CApp()
{
}

// Initialization
BOOL CApp::InitInstance()
{
	InitCommonControls();
	
	CWinApp::InitInstance();
	
#ifdef _DEBUG
	srand(0);
#else
	srand(GetTickCount() ^ GetCurrentThreadId());
#endif
	
	// Settings
	SetRegistryKey(_T("Ryder"));
	LoadStdProfileSettings(4);
	
	{
		#define DEFAULT(name, min,max, def, id) \
			m_ndDefault.name = def;
		NODEDATA_ENUM(DEFAULT)
		#undef DEFAULT
		m_ndDefault.m_fStats = true;
		
		NODEDATA *pnd;
		UINT len;
		if (GetProfileBinary(pszMain, pszDefaultNode, (BYTE**)&pnd, &len))
			if (len==sizeof(*pnd))
				m_ndDefault = *pnd;
		delete [] pnd;
	}
	
	
	// Create doc template
	AddDocTemplate(new CMultiDocTemplate(
		IDR_TYPE,
		RUNTIME_CLASS(CDoc),
		RUNTIME_CLASS(CChildFrame),
		RUNTIME_CLASS(CGraphView)));
	
	
	// Create main MDI frame
	CMainFrame* pMainFrame = new CMainFrame;
	VERIF(pMainFrame->LoadFrame(IDR_MAINFRAME));
	m_pMainWnd = pMainFrame;
	
	// Create properties window
	e_dlgProp.Create(e_dlgProp.IDD);
	
	// Some configuration
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	
	// Command line
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	VERIF(ProcessShellCommand(cmdInfo));
	
	// Show main frame
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	
	
	return TRUE;
}


// Exiting
int CApp::ExitInstance()
{
	return CWinApp::ExitInstance();
}


// About
void CApp::OnAppAbout()
{
	CDialog(IDD_ABOUT).DoModal();
}


// Get the current view
CGraphView* CApp::GetActiveView()
{
	if (!app.m_pMainWnd)
		return NULL;
	
	CFrameWnd *const pFrame = ((CFrameWnd*)app.m_pMainWnd)->GetActiveFrame();
	return (pFrame)
		? (CGraphView*)pFrame->GetActiveView()
		: NULL;
}
